=== ifs_samples/CMakeLists.txt ===
add_subdirectory( grib1 )

add_subdirectory( grib1_mlgrib2 )

# add_subdirectory( grib1_mlgrib2_ieee32 )

add_subdirectory( grib1_mlgrib2_ieee64 )
