=== ifs_samples/grib1/CMakeLists.txt ===
set( _basedir grib1 )

list( APPEND ifs_samples_${_basedir}
      gg_ml.tmpl
      gg_sfc.tmpl
      sh_ml.tmpl
      sh_sfc.tmpl
)

install( FILES ${GRIB_API_SAMPLES_FILES} ${ifs_samples_${_basedir}}  
         DESTINATION ${GRIB_API_IFS_SAMPLES_PATH}/${_basedir}
         PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ )

file( COPY ${ifs_samples_${_basedir}}
      DESTINATION ${CMAKE_BINARY_DIR}/share/${PROJECT_NAME}/ifs_samples/${_basedir} )
