=== debian/changelog ===
grib-api (1.14.4-5) unstable; urgency=medium

  * Add libpng-dev, zlib1g-dev, libjpeg-dev, libjasper-dev to lgrib-api-dev
    dependencies, because cmake build scripts make compiles depend on them.
  * Add patch for Hurd compilation.

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 13 Jan 2016 08:48:13 +0000

grib-api (1.14.4-4) unstable; urgency=medium

  * Don't record build paths in ecbuild_config.h. Breaks reproducibility.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 12 Jan 2016 20:18:55 +0000

grib-api (1.14.4-3) unstable; urgency=medium

  * libgrib-api-dev depends on libaec-dev as it ships dependencies in the
     cmake scripts.
  * Drop chrpath in favor of using ENABLE_RPATH=OFF in cmake
  * Build-Conflict on libgrib-api-dev, to avoid incorrect libs being
    used during testing. Set LD_LIBRARY_PATH during testing to find
    correct libs.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 12 Jan 2016 11:05:52 +0000

grib-api (1.14.4-2) unstable; urgency=medium

  * Add /usr/lib/cmake/grib_api/* files to -dev package for magics++
  * Add new binaries to /usr/bin in libgrib-api-tools

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 07 Jan 2016 04:56:40 +0000

grib-api (1.14.4-1) unstable; urgency=medium

  * New upstream release.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 05 Jan 2016 01:35:45 +0000

grib-api (1.14.3-2) unstable; urgency=medium

  * Make builds reproducible.
  * Links libs --as-needed
  * Set DISABLE_OS_CHECK=ON for Hurd, etc.

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 07 Dec 2015 07:29:31 +0000
